
var omvivaBinded = false;
var postFilterCount = false;
var postMap = {

  init : function(){
    
  var postcode = "";  
  
    var self = this;
      var postCachedSearch = [];
//jQuery('document').ready(function(jQuery){
  var currentLocationIcon = false;
  var autoSelectTerminal = false;
  jQuery('#postMapContainer').html('<div id="postMap"></div>');
  var map = L.map('postMap').setView([56.92797234798372, 23.987533500272825], 8);

  L.tileLayer('https://maps.wikimedia.org/osm-intl/{z}/{x}/{y}.png', {
		attribution: '&copy; <a href="https://www.pasts.lv">post</a>'
	}).addTo(map);

	var Icon = L.Icon.extend({
		options: {
			//shadowUrl: 'leaf-shadow.png',
			iconSize:     [29, 34],
			//shadowSize:   [50, 64],
			iconAnchor:   [15, 34],
			//shadowAnchor: [4, 62],
			popupAnchor:  [-3, -76]
		}
	});
  
  var Icon2 = L.Icon.extend({
		options: {
			iconSize:     [32, 32],
			iconAnchor:   [16, 32]
		}
	});
	var terminalIcon = new Icon({iconUrl: postdata.post_plugin_url+'assets/img/sasi.png'});
  var homeIcon = new Icon2({iconUrl: postdata.post_plugin_url+'assets/img/locator_img.png'});
  var select_terminal = postdata.text_select_terminal;
  var not_found = postdata.not_found;
  
  var locations = JSON.parse(postTerminals);
    jQuery.each( locations, function( key, location ) {
      L.marker([location[1], location[2]], {icon: terminalIcon, terminalId:location[3] }).on('click',function(e){ listTerminals(locations,0,this.options.terminalId);terminalDetails(this.options.terminalId);}).addTo(map);
    });
  
  //show button
  jQuery('#show-post-map').show();
  if (!omvivaBinded){     
   
    jQuery('#post-search form').on('submit',function(e){
      e.preventDefault();
      var postcode = jQuery('#post-search form input').val();
      searchPostcode(postcode);
    });
    
    var timeoutID = null;
    
    jQuery('#post-search form input').on('keyup focus',function(){
        clearTimeout(timeoutID);      
        timeoutID = setTimeout(function(){ autoComplete(jQuery('#post-search form input').val())}, 500);    
              
    });
    
    jQuery('.post-autocomplete ul').on('click','li',function(){
        if (jQuery(this).attr('data-location-y') !== undefined){
            setCurrentLocation([jQuery(this).attr('data-location-y'),jQuery(this).attr('data-location-x')]);
        }
        jQuery('.post-autocomplete').hide();
    });
    jQuery(document).click(function(e){
        var container = jQuery(".post-autocomplete");
        if (!container.is(e.target) && container.has(e.target).length === 0) 
            container.hide();
    });
  
    jQuery('#terminalsModal').on('click',function(){jQuery('#postModal').hide();});
    //jQuery('body').on('click','#show-post-map',showModal);
    
    /*
    jQuery('#shipping_postcode').on('change',function(){
      if (jQuery('#ship-to-different-address-checkbox').length > 0 && jQuery('#ship-to-different-address-checkbox').is(':checked')){
        postcode = jQuery(this).val();
        searchPostcode(postcode);
        autoSelectTerminal = true;
      }
    });
    jQuery('#billing_postcode').on('change',function(){
      if (jQuery('#ship-to-different-address-checkbox').length > 0 && !jQuery('#ship-to-different-address-checkbox').is(':checked')){
        postcode = jQuery(this).val();
        searchPostcode(postcode);
        autoSelectTerminal = true;
      }
    });
    */
    
      
    
    
     omvivaBinded = true;
  }
  /*
  jQuery('.post_terminal').on('select2:open', function (e) {
        jQuery(".post_terminal").data("select2").dropdown.$search.val(postcode).trigger('keyup');
        //console.log(postcode);
    });
  if (postcode == ""){
        if (jQuery('#ship-to-different-address-checkbox').length > 0 && jQuery('#ship-to-different-address-checkbox').is(':checked')){
            postcode = jQuery('#shipping_postcode').val();
        }  
        if (jQuery('#ship-to-different-address-checkbox').length > 0 && !jQuery('#ship-to-different-address-checkbox').is(':checked')){
            postcode = jQuery('#billing_postcode').val();
        }
        searchPostcode(postcode);
        autoSelectTerminal = true;
      }
      */
      /*
  function showModal(){
      if (jQuery('.post-terminals-list input.search-input').val() != ''){
          jQuery('#post-search input').val(jQuery('.post-terminals-list input.search-input').val());
          jQuery('#post-search button').trigger('click')
      }
    jQuery('#postModal').show();
    getLocation();
    var event;
    if(typeof(Event) === 'function') {
        event = new Event('resize');
    }else{
        event = document.createEvent('Event');
        event.initEvent('resize', true, true);
    }
    window.dispatchEvent(event);
    //console.log('1');
  }
  */
   
    jQuery('#shipping_postcode, #billing_postcode').trigger('change');
 
  function getLocation() {
      if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(function(loc) {
          if (postcode == ""){
        setCurrentLocation([loc.coords.latitude, loc.coords.longitude]);
          }
        });
      } 
    }
    
  function searchPostcode(postcode){
    if (postcode == "") return false;
    jQuery('#post-search form input').val(postcode);
    jQuery.getJSON( "http://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/findAddressCandidates?singleLine="+postcode+"&sourceCountry="+post_current_country+"&category=&outFields=Postal&maxLocations=1&forStorage=false&f=pjson", function( data ) {
      if (data.candidates != undefined && data.candidates.length > 0){
        if (data.candidates[0].score > 90){
          setCurrentLocation([data.candidates[0].location.y,data.candidates[0].location.x]);
        } else {
          jQuery('.found_terminals').html(not_found);
        }
      } else {
        jQuery('.found_terminals').html(not_found);
      }
    });
  }
  
  function autoComplete(address){
    jQuery('.post-autocomplete ul').html('');
    jQuery('.post-autocomplete').hide();
    if (address == "" || address.length < 3) return false;
    jQuery('#post-search form input').val(address);
    jQuery.getJSON( "http://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/findAddressCandidates?singleLine="+address+"&sourceCountry="+post_current_country+"&category=&outFields=Postal&maxLocations=5&forStorage=false&f=pjson", function( data ) {
      if (data.candidates != undefined && data.candidates.length > 0){
          jQuery.each(data.candidates ,function(i,item){
            //console.log(item);
            const li = jQuery("<li data-location-y = '"+item.location.y+"' data-location-x = '"+item.location.x+"'>"+item.address+"</li>");
            jQuery(".post-autocomplete ul").append(li);
          });
      }
          if (jQuery(".post-autocomplete ul li").length == 0){
              jQuery(".post-autocomplete ul").append('<li>'+not_found+'</li>');
          }
      jQuery('.post-autocomplete').show();
    });
  }
  
  /*
  getTerminalsId = function(postcode){
    if (postcode == "") return false;
    if (postCachedSearch[postcode] !== undefined) return postCachedSearch[postcode];
    //jQuery('#post-search form input').val(postcode);

    jQuery.ajax({ dataType: "json", async:false, url:"http://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/findAddressCandidates?singleLine="+postcode+"&sourceCountry="+post_current_country+"&category=&outFields=Postal&maxLocations=1&forStorage=false&f=pjson", success : function( data ) {
      if (data.candidates != undefined && data.candidates.length > 0){
        if (data.candidates[0].score > 90){
          var terminals = findClosest([data.candidates[0].location.y,data.candidates[0].location.x],true);
          //console.log(terminals);
          var filteredTerminals = [];
          var counter = 0;
          jQuery.each( terminals, function( key, location ) {
            filteredTerminals.push([location[3],location['distance'],location[4]]);
            counter++;
            if (counter>=8) return false;
          });
          postCachedSearch[postcode] = filteredTerminals;
          return filteredTerminals;
        } else {
          postCachedSearch[postcode] = [];
        }
        return false;
        
    }}
    });
  }
  */
  setCurrentLocation = function(pos){
    if (currentLocationIcon){
      map.removeLayer(currentLocationIcon);
    }
    //console.log('home');
    currentLocationIcon = L.marker(pos, {icon: homeIcon}).addTo(map);
    map.setView(pos,16);
    findClosest(pos);
  }
  
  function listTerminals(locations,limit,id){
      if (limit === undefined){
          limit=0;
      }
      if (id === undefined){
          id=0;
      }
     var html = '', counter=1;
    jQuery('.found_terminals').html('');
    jQuery.each( locations, function( key, location ) {
      if (limit != 0 && limit < counter){
        return false;
      }
      if (id !=0 && id != location[3]){
        return true;
      }
      if (autoSelectTerminal && counter == 1){
        terminalSelected(location[3],false);
      }
      var destination = [location[1], location[2]]
      var distance = 0;
      if (location['distance'] != undefined){
        distance = location['distance'];
      }
      html += '<li onclick="zoomTo(['+destination+'],'+location[3]+')" ><div><a class="post-li">'+counter+'. <b>'+location[0]+'</b></a> <b>'+distance+' km.</b>\
                                  <div align="left" id="omn-'+location[3]+'" class="post-details" style="display:none;"><small>\
                                  '+location[5]+' <br/>'+location[6]+'</small><br/>\
                                  <button type="button" class="btn-marker" style="font-size:14px; padding:0px 5px;margin-bottom:10px; margin-top:5px;height:25px;" onclick="terminalSelected('+location[3]+')">'+select_terminal+'</button>\
                                  </div>\
                                  </div></li>';
                                      
                      counter++;           
                       
    });
    document.querySelector('.found_terminals').innerHTML = '<ul class="post-terminals-listing" start="1">'+html+'</ul>';
    if (id != 0){
        map.eachLayer(function (layer) { 
            if (layer.options.terminalId !== undefined && L.DomUtil.hasClass(layer._icon, "active")){
                L.DomUtil.removeClass(layer._icon, "active");
            }
            if (layer.options.terminalId == id) {
                //layer.setLatLng([newLat,newLon])
                L.DomUtil.addClass(layer._icon, "active");
            } 
        });
    }
  }
  
  zoomTo = function(pos, id){
    terminalDetails(id);
    map.setView(pos,14);
    map.eachLayer(function (layer) { 
        if (layer.options.terminalId !== undefined && L.DomUtil.hasClass(layer._icon, "active")){
            L.DomUtil.removeClass(layer._icon, "active");
        }
        if (layer.options.terminalId == id) {
            //layer.setLatLng([newLat,newLon])
            L.DomUtil.addClass(layer._icon, "active");
        } 
    });
  }
  
  terminalSelected = function(terminal,close) {
      if (close === undefined){
          close = true;
      }
          var matches = document.querySelectorAll(".postOption");
          for (var i = 0; i < matches.length; i++) {
            node = matches[i]
            if ( node.value.includes(terminal)) {
              node.selected = 'selected';
            } else {
              node.selected = false;
            }
          }
                
          jQuery('select[name="post_terminal"]').val(terminal);
          jQuery('select[name="post_terminal"]').trigger("change");
          if (close){
            jQuery('#postModal').hide();
          }
        }
  
  function terminalDetails(id) {
                terminals = document.querySelectorAll(".post-details")
                for(i=0; i <terminals.length; i++) {
                    terminals[i].style.display = 'none';
                }
                id = 'omn-'+id;
                disppost = document.getElementById(id)
                
                if(disppost)
                    disppost.style.display = 'block';
                  
  }
    function toRad(Value) 
        {
            return Value * Math.PI / 180;
        }
    
        function calcCrow(lat1, lon1, lat2, lon2) 
        {
          var R = 6371;
          var dLat = toRad(lat2-lat1);
          var dLon = toRad(lon2-lon1);
          var lat1 = toRad(lat1);
          var lat2 = toRad(lat2);
    
          var a = Math.sin(dLat/2) * Math.sin(dLat/2) +
            Math.sin(dLon/2) * Math.sin(dLon/2) * Math.cos(lat1) * Math.cos(lat2); 
          var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
          var d = R * c;
          return d;
        }
        
  function findClosest(pos,filter) {
    if (filter === undefined){
        filter = false;
    }
      jQuery.each( locations, function( key, location ) {
        distance = calcCrow(pos[0], pos[1], location[1], location[2]);
        location['distance'] = distance.toFixed(2);
        
      });
    
                locations.sort(function(a, b) {
                    var distOne = a['distance']
                    var distTwo = b['distance']
                    if (parseFloat(distOne) < parseFloat(distTwo)) {
                        return -1;
                    }
                    if (parseFloat(distOne) > parseFloat(distTwo)) {
                        return 1;
                    }
                    return 0;
                })
    
        if (filter){
          return locations;
        } else {
        listTerminals(locations,8);
        }
  }
       
  }    
}